
var developer_tool = false;
var mission_in_bounds = [];
var not_exists_count;

function update_mission_in_bounds(tabId){

	$.ajax("https://ingressmm.com/mission_exists.php", {
		type: "post",
		data: { mid: mission_in_bounds },
		dataType: "JSON",
		complete: function(rsl, stat, xhr){
			if (typeof rsl.responseJSON != "undefined")
				var exists = {}, i;
				not_exists_count = 0;
				for(i in mission_in_bounds){
					exists[mission_in_bounds[i]] = developer_tool ? "imm_uploadable" : "imm_nothing";
					not_exists_count++;
				}
				for(i in rsl.responseJSON){
					exists[rsl.responseJSON[i]] = "imm_exists";
					not_exists_count--;
				}
//				chrome.browserAction.setBadgeText({ text: String(!not_exists_count ? "" : not_exists_count) });
				chrome.tabs.sendRequest(tabId, {
					command: "modify_mission_list",
					exists: exists,
					not_exists_count: not_exists_count
				}, function(response){});
		}
	});
}

chrome.webRequest.onCompleted.addListener(function(details){

	setTimeout(function(){
		chrome.tabs.sendRequest(details.tabId, {
			command: "collect_mission_list"
		}, function(response){
			mission_in_bounds = response;
			update_mission_in_bounds(details.tabId)
		});
	}, 1000);

}, { urls: [ "*://intel.ingress.com/r/getTopMissionsInBounds" ] });

chrome.extension.onRequest.addListener(function(request){
	chrome.windows.getCurrent(function(win){
		chrome.tabs.getSelected(win.id, function(tab){

			switch(request.url){
				case "getTopMissionsInBounds":
					developer_tool = true;
					break;

				case "getMissionDetails":
					$.ajax("https://ingressmm.com/post.php", {
						type: "post",
						data: { data: request.result },
						dataType: "JSON",
						success: function(data, stat, xhr){
							update_mission_in_bounds(tab.id);
						}
					});
					break;
			}
		});
	});
});

